## cmtk 2.1.0

=== CMakeLists.txt ===
##
##  Copyright 1997-2010 Torsten Rohlfing
##
##  Copyright 2004-2011 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3574 $
##
##  $LastChangedDate: 2011-11-21 11:00:23 -0800 (Mon, 21 Nov 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

##
## This file borrows heavily from the analogous InsightToolkit file
##

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
SET(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required

IF(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW) ## libraries with full paths vs. search paths
ENDIF(COMMAND cmake_policy)
SET(CMAKE_OVERRIDE_COMPILER_MISMATCH 1)

PROJECT(CMTK)
SET(CMTK_VERSION_MAJOR "2")
SET(CMTK_VERSION_MINOR "1")
SET(CMTK_VERSION_PATCH "0")

SET(CMTK_VERSION_STRING "${CMTK_VERSION_MAJOR}.${CMTK_VERSION_MINOR}.${CMTK_VERSION_PATCH}")

#-----------------------------------------------------------------------------
# Test for some required system information.
INCLUDE (${CMAKE_ROOT}/Modules/CMakeDetermineSystem.cmake)
INCLUDE (${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeSystem.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityC.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityCXX.cmake)

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake)

#-----------------------------------------------------------------------------
# Output directories.
IF(NOT LIBRARY_OUTPUT_PATH)
  SET (LIBRARY_OUTPUT_PATH ${CMTK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET (EXECUTABLE_OUTPUT_PATH ${CMTK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)
MARK_AS_ADVANCED(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)
IF(NOT CMTK_BUILD_LIB_DIR) # variable used for generating CMTKConfig.cmake for the build tree
  SET(CMTK_BUILD_LIB_DIR "/bin")
ENDIF(NOT CMTK_BUILD_LIB_DIR)

SET(CMTK_LIBRARY_PATH "${LIBRARY_OUTPUT_PATH}")
SET(CMTK_EXECUTABLE_PATH "${EXECUTABLE_OUTPUT_PATH}")
SET(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

# set CMTK_DIR so it can be used by subprojects
SET(CMTK_DIR "${CMAKE_BINARY_DIR}" CACHE INTERNAL "CMTK dir to be used by subprojects")

#-----------------------------------------------------------------------------
# Setup install target directories
IF(NOT CMTK_INSTALL_BIN_DIR)
  SET(CMTK_INSTALL_BIN_DIR bin CACHE PATH "Binary files will be installed here")
ENDIF(NOT CMTK_INSTALL_BIN_DIR)

IF(NOT CMTK_INSTALL_LIB_DIR)
  # 64 bit libraries are not installed in the same directories on solaris
  # Ref: http://docs.sun.com/app/docs/doc/816-5138/6mba6ua5m?a=view
  SET(sun64 )
  IF(CMAKE_SYSTEM MATCHES "SunOS.*" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    EXEC_PROGRAM("uname"
      ARGS "-p"
      OUTPUT_VARIABLE sunproc
    )
    IF("${sunproc}" STREQUAL "sparc")
      SET(sun64 "/sparcv9")
    ENDIF("${sunproc}" STREQUAL "sparc")

    IF("${sunproc}" STREQUAL "i386")
      SET(sun64 "/amd64")
    ENDIF("${sunproc}" STREQUAL "i386")

    IF("${sun64}" STREQUAL "")
      # sun64 is not set - solaris has been ported to a new architecture?
      MESSAGE("Warning: Unknown processor '${sunproc}'. The libraries may not be installed in the right place.")
    ENDIF("${sun64}" STREQUAL "")
  ENDIF(CMAKE_SYSTEM MATCHES "SunOS.*" AND CMAKE_SIZEOF_VOID_P EQUAL 8)

  SET(CMTK_INSTALL_LIB_DIR "lib${sun64}/cmtk" CACHE PATH "Library files will be installed here")
ENDIF(NOT CMTK_INSTALL_LIB_DIR)

IF(NOT CMTK_INSTALL_DATA_DIR)
  SET(CMTK_INSTALL_DATA_DIR "share/cmtk" CACHE PATH "Data files will be installed here")
ENDIF(NOT CMTK_INSTALL_DATA_DIR)

IF(NOT CMTK_INSTALL_INCLUDE_DIR)
  SET(CMTK_INSTALL_INCLUDE_DIR "include/cmtk" CACHE PATH "Data files will be installed here")
ENDIF(NOT CMTK_INSTALL_INCLUDE_DIR)

#-----------------------------------------------------------------------------
# Check for system headers.
INCLUDE (CheckIncludeFiles)
CHECK_INCLUDE_FILES (dirent.h HAVE_DIRENT_H)
CHECK_INCLUDE_FILES (execinfo.h HAVE_EXECINFO_H)
CHECK_INCLUDE_FILES (fcntl.h HAVE_FCNTL_H)
CHECK_INCLUDE_FILES (ieeefp.h HAVE_IEEEFP_H)
CHECK_INCLUDE_FILES (inttypes.h HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES (malloc.h HAVE_MALLOC_H)
CHECK_INCLUDE_FILES (pthread.h HAVE_PTHREAD_H)
CHECK_INCLUDE_FILES (stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILES (termios.h HAVE_TERMIOS_H)
CHECK_INCLUDE_FILES (unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES (values.h HAVE_VALUES_H)

CHECK_INCLUDE_FILES (sys/ioctl.h HAVE_SYS_IOCTL_H)
CHECK_INCLUDE_FILES (sys/procfs.h HAVE_SYS_PROCFS_H)
CHECK_INCLUDE_FILES (sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES (sys/time.h HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES (sys/times.h HAVE_SYS_TIMES_H)
CHECK_INCLUDE_FILES (sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES (sys/utsname.h HAVE_SYS_UTSNAME_H)

INCLUDE(TestBigEndian)
TEST_BIG_ENDIAN(WORDS_BIGENDIAN)

#-----------------------------------------------------------------------------
# Test NaN high bit
INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/CMake/TestQnanhibit.cmake)
TEST_QNANHIBIT(QNANHIBIT_VALUE ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
IF(QNANHIBIT_VALUE)
  SET(QNANHIBIT 1 CACHE INTERNAL "The 22nd bit of 32-bit floating-point quiet NaN.")
ELSE(QNANHIBIT_VALUE)
  SET(QNANHIBIT 0 CACHE INTERNAL "The 22nd bit of 32-bit floating-point quiet NaN.")
ENDIF(QNANHIBIT_VALUE)

#-----------------------------------------------------------------------------
# Check for at least one of the typical STL hash map implementations

INCLUDE (CheckIncludeFileCXX)
CHECK_INCLUDE_FILE_CXX(unordered_map HAVE_UNORDERED_MAP)
IF(NOT HAVE_UNORDERED_MAP)
  CHECK_INCLUDE_FILE_CXX(tr1/unordered_map HAVE_UNORDERED_MAP_TR1)
  IF(NOT HAVE_UNORDERED_MAP_TR1)
    CHECK_INCLUDE_FILE_CXX(hash_map HAVE_HASH_MAP)
    IF(NOT HAVE_HASH_MAP)
      CHECK_INCLUDE_FILE_CXX(hash_map.h HAVE_HASH_MAP_H)
    ENDIF(NOT HAVE_HASH_MAP)
  ENDIF(NOT HAVE_UNORDERED_MAP_TR1)
ENDIF(NOT HAVE_UNORDERED_MAP)

# set a single flag is we have ANY hash map implementation in STL
SET(HAVE_STL_HASH_MAP ${HAVE_UNORDERED_MAP}${HAVE_UNORDERED_MAP_TR1}${HAVE_HASH_MAP}${HAVE_HASH_MAP_H} CACHE INTERNAL "Flag for presence of ANY hash map implementation in the C++ STL")

#-----------------------------------------------------------------------------
# build configuration options.
OPTION(BUILD_SHARED_LIBS "Build CMTK with shared libraries." OFF)
SET(CMTK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

OPTION(CMTK_BUILD_WRAPPER "Build 'cmtk' wrapper script and install all actual executables in a private directory to avoid name collisions" OFF)
MARK_AS_ADVANCED(CMTK_BUILD_WRAPPER)

OPTION(CMTK_BUILD_UNSTABLE "Build 'unstable' library and tools" OFF)
MARK_AS_ADVANCED(CMTK_BUILD_UNSTABLE)

OPTION(CMTK_BUILD_STACKTRACE "Build tools with stack trace printing in case of crash (increases build time)" ON)
MARK_AS_ADVANCED(CMTK_BUILD_STACKTRACE)

OPTION(CMTK_BUILD_DEMO "Build demonstration code. Strange things will happen if you turn this on." OFF)
MARK_AS_ADVANCED(CMTK_BUILD_DEMO)
IF(CMTK_BUILD_DEMO)
  MESSAGE( WARNING "Demo mode is enabled. Make sure not to use this build for production use!")
ENDIF(CMTK_BUILD_DEMO)

#-----------------------------------------------------------------------------
# Add an option to use or not to use MPI distributed-memory parallelism

OPTION(CMTK_USE_MPI "Use MPI for distributed-memory parallelism" OFF)
MARK_AS_ADVANCED(CMTK_USE_MPI)

OPTION(CMTK_USE_SMP "Enable shared-memory parallelism (requires at least POSIX Threads, OpenMP, or Windows threads)" ON)

#-----------------------------------------------------------------------------
# Add an option to enable or disable POSIX threads if pthread.h header exists

IF(HAVE_PTHREAD_H)
  OPTION(CMTK_USE_PTHREADS "Use POSIX Threads for SMP parallelism" ON)
  MARK_AS_ADVANCED(CMTK_USE_PTHREADS)

  IF(NOT CMTK_USE_SMP)
    SET(CMTK_USE_PTHREADS OFF)
  ENDIF(NOT CMTK_USE_SMP)
ENDIF(HAVE_PTHREAD_H)

#-----------------------------------------------------------------------------
# for the gnu compiler a -D_PTHREADS is needed on sun
# for the native compiler a -mt flag is needed on the sun
IF(CMTK_USE_PTHREADS)

  IF(${CMAKE_SYSTEM} MATCHES "SunOS.*")
    IF(CMAKE_COMPILER_IS_GNUCXX)
      SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} -D_PTHREADS")
    ELSE(CMAKE_COMPILER_IS_GNUCXX)
      SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} -mt")
      SET(CMTK_REQUIRED_C_FLAGS "${CMTK_REQUIRED_C_FLAGS} -mt")
    ENDIF(CMAKE_COMPILER_IS_GNUCXX)
  ENDIF(${CMAKE_SYSTEM} MATCHES "SunOS.*")
ENDIF(CMTK_USE_PTHREADS)

# mingw thread support
IF(MINGW)
  SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} -mthreads")
  SET(CMTK_REQUIRED_C_FLAGS "${CMTK_REQUIRED_C_FLAGS} -mthreads")
  SET(CMTK_REQUIRED_LINK_FLAGS "${CMTK_REQUIRED_LINK_FLAGS} -mthreads")
ENDIF(MINGW)

#-----------------------------------------------------------------------------
# Check for, and configure, OpenMP

IF(NOT DEFINED CMTK_USE_OPENMP)
  IF (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION} STRLESS 2.6.2)
    MESSAGE("Warning.  We need at least CMake 2.6.2 to check for OpenMP support. You have version ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION}")
  ELSE (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION} STRLESS 2.6.2)
    FIND_PACKAGE(OpenMP)
    IF(OPENMP_FOUND)
      OPTION(CMTK_USE_OPENMP "Use OpenMP for SMP parallelism" ON)
      MARK_AS_ADVANCED(CMTK_USE_OPENMP)
      
      IF(NOT CMTK_USE_SMP)
	SET(CMTK_USE_OPENMP OFF)
      ENDIF(NOT CMTK_USE_SMP)
    ENDIF(OPENMP_FOUND)
  ENDIF (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION} STRLESS 2.6.2)
ENDIF(NOT DEFINED CMTK_USE_OPENMP)

IF(CMTK_USE_OPENMP)
  SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  SET(CMTK_REQUIRED_LINK_FLAGS "${CMTK_REQUIRED_LINK_FLAGS} ${OpenMP_C_FLAGS}")
ENDIF(CMTK_USE_OPENMP)

#-----------------------------------------------------------------------------
# Check for, and configure, Grand Central Dispatch

CHECK_INCLUDE_FILES(dispatch/dispatch.h HAVE_DISPATCH_H)
IF(HAVE_DISPATCH_H)
  OPTION(CMTK_USE_GCD "Use Grand Central Dispatch for SMP parallelism with system-level load balancing" ON)
  
  IF(NOT CMTK_USE_SMP)
    SET(CMTK_USE_GCD OFF)
  ENDIF(NOT CMTK_USE_SMP)
  
  IF(CMTK_USE_GCD)
  ENDIF(CMTK_USE_GCD)
ENDIF(HAVE_DISPATCH_H)

#-----------------------------------------------------------------------------
# Check for, and configure, OpenCL

##    OPTION(CMTK_USE_OPENCL "Use OpenCL for GPU computing" OFF)
##  IF(CMTK_USE_OPENCL)
##  INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/CMake/FindOpenCL.cmake)
##  IF(OPENCL_FOUND)
##  ENDIF(OPENCL_FOUND)
##
##    ADD_DEFINITIONS(-DCMTK_USE_OPENCL)
##  ENDIF(CMTK_USE_OPENCL)

#-----------------------------------------------------------------------------
# Check for, and configure, CUDA

OPTION(CMTK_USE_CUDA "Use CUDA for GPU computing" OFF)

IF(CMTK_USE_CUDA)

  # check using cmake's own FindCUDA above v2.8 or use our own for earlier versions
  IF (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STRLESS 2.8)
    INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/CMake/FindCUDA.cmake)

=== Utilities/CMakeLists.txt ===
##
##  Copyright 1997-2009 Torsten Rohlfing
##
##  Copyright 2004-2009 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3446 $
##
##  $LastChangedDate: 2011-10-07 13:54:06 -0700 (Fri, 07 Oct 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

# turn off Windows security warnings for bundled code
IF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

IF(CMTK_BUILD_ZLIB)
  SUBDIRS(zlib)
ENDIF(CMTK_BUILD_ZLIB)

IF(CMTK_BUILD_NRRD)
  SUBDIRS(NrrdIO)
ENDIF(CMTK_BUILD_NRRD)

IF(CMTK_BUILD_DCMTK)
  SUBDIRS(dcmtk)
ENDIF(CMTK_BUILD_DCMTK)

IF(CMTK_BUILD_MXML)
  SUBDIRS(mxml)
ENDIF(CMTK_BUILD_MXML)

IF(CMTK_BUILD_SQLITE)
  SUBDIRS(sqlite3)
ENDIF(CMTK_BUILD_SQLITE)

=== apps/CMakeLists.txt ===
##
##  Copyright 1997-2010 Torsten Rohlfing
##
##  Copyright 2004-2011 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3567 $
##
##  $LastChangedDate: 2011-11-11 03:57:46 -0800 (Fri, 11 Nov 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

SET(CMTK_LIBRARIES "cmtkSegmentation;cmtkRecon;cmtkRegistration;cmtkIO;cmtkBase;cmtkNumerics;cmtkSystem")
IF(CMTK_BUILD_UNSTABLE)
  SET(CMTK_LIBRARIES "cmtkUnstable;${CMTK_LIBRARIES}")
ENDIF(CMTK_BUILD_UNSTABLE)

SET(APPS avg_adm
  describe
  groupwise_init
  groupwise_affine
  groupwise_warp
  )

IF(CMTK_USE_CUDA)
  SET(CUDA_APPS 
    levelset_cuda
    mrbias_cuda
    symplx_cuda)
ENDIF(CMTK_USE_CUDA)

IF(CMTK_USE_OPENCL)
ENDIF(CMTK_USE_OPENCL)

IF(NOT CMTK_USE_MPI)
  SET(APPS ${APPS}
    asegment
    average_affine
    average_edt
    average_images
    average_labels
    concat_affine
    convertx
    convert_warp
    destripe
    film
    filter
    glm
    gregxform
    hausdorff
    histogram
    imagemath
    jidb
    levelset
    make_initial_affine
    mat2dof
    mip
    mk_analyze_hdr
    mk_nifti_hdr
    mk_phantom_3d
    mrbias
    overlap
    probe
    reformatx
    registration
    registrationx
    regress
    reorient
    sequence
    similarity
    split
    statistics
    sympl
    symplx
    ttest
    unsplit
    volume_injection
    volume_reconstruction
    vtkxform
    warp
    warpx
    warp2ps
    xform2dfield
    xform2itk
    xform2scalar)
  
  IF(CMTK_USE_SQLITE)
    SET(APPS ${APPS}
      dbtool)
  ENDIF(CMTK_USE_SQLITE)
  
  IF(CMTK_ROOT_PATH_SRI24)
    SET(APPS ${APPS} asegment_sri24)
  ENDIF(CMTK_ROOT_PATH_SRI24)
  
  IF(HAVE_STL_HASH_MAP)
    SET(APPS ${APPS} mcaffine mcwarp)
  ENDIF(HAVE_STL_HASH_MAP)
  
  IF(CMTK_USE_DCMTK)
    SET(APPS ${APPS} dcm2image)
  ENDIF(CMTK_USE_DCMTK)

  IF (CMTK_BUILD_UNSTABLE)
    SET(APPS ${APPS} lsba lvote)
  ENDIF (CMTK_BUILD_UNSTABLE)
  
ENDIF(NOT CMTK_USE_MPI)

FOREACH(APPLICATION ${APPS})
  ADD_EXECUTABLE(${APPLICATION} ${APPLICATION}.cxx)
  TARGET_LINK_LIBRARIES(${APPLICATION} ${CMTK_LIBRARIES} ${CMTK_SYSTEM_LIBRARIES})

  IF(CMTK_BUILD_WRAPPER)
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT tools)
    SET(manpage cmtk-${APPLICATION}.1)
  ELSE(CMTK_BUILD_WRAPPER)    
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
    SET(manpage ${APPLICATION}.1)
  ENDIF(CMTK_BUILD_WRAPPER)
  
  IF(BUILD_MANPAGES)
    ADD_CUSTOM_COMMAND(
      OUTPUT ${manpage}
      COMMAND ${APPLICATION} --man ">" ${manpage}
      DEPENDS ${APPLICATION})
    ADD_CUSTOM_TARGET(man_${APPLICATION} ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${manpage})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${manpage} DESTINATION share/man/man1 COMPONENT tools)  
  ENDIF(BUILD_MANPAGES)
ENDFOREACH(APPLICATION ${APPS})

FOREACH(APPLICATION ${CUDA_APPS})
  CUDA_ADD_EXECUTABLE(${APPLICATION} ${APPLICATION}.cxx)
  TARGET_LINK_LIBRARIES(${APPLICATION} cmtkGPU ${CMTK_LIBRARIES} ${CMTK_SYSTEM_LIBRARIES})

  IF(CMTK_BUILD_WRAPPER)
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT tools)
  ELSE(CMTK_BUILD_WRAPPER)    
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
  ENDIF(CMTK_BUILD_WRAPPER)
ENDFOREACH(APPLICATION ${CUDA_APPS})

IF(CMTK_USE_CUDA)
  CUDA_ADD_EXECUTABLE(cudatest cudatest.cxx)

  IF(CMTK_BUILD_WRAPPER)
    INSTALL(TARGETS cudatest RUNTIME DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT tools)
  ELSE(CMTK_BUILD_WRAPPER)    
    INSTALL(TARGETS cudatest RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
  ENDIF(CMTK_BUILD_WRAPPER)
ENDIF(CMTK_USE_CUDA)

=== gui/CMakeLists.txt ===
##
##  Copyright 1997-2009 Torsten Rohlfing
##
##  Copyright 2004-2011 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3568 $
##
##  $LastChangedDate: 2011-11-11 04:48:42 -0800 (Fri, 11 Nov 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

SET(CMTK_LIBRARIES "cmtkQt;cmtkPipeline;cmtkSegmentation;cmtkRegistration;cmtkIO;cmtkBase;cmtkNumerics;cmtkSystem")

SUBDIRS(triplanar)
SUBDIRS(fview)

IF(CMTK_BUILD_UNSTABLE)
  SUBDIRS(bsedit)
ENDIF(CMTK_BUILD_UNSTABLE)

=== libs/CMakeLists.txt ===
##
##  Copyright 1997-2009 Torsten Rohlfing
##
##  Copyright 2004-2011 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3561 $
##
##  $LastChangedDate: 2011-11-10 07:19:42 -0800 (Thu, 10 Nov 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

SET(BUILD_LIBS_LIST System Numerics Base IO Registration Segmentation Recon)

IF(CMTK_USE_QT)
  SET(BUILD_LIBS_LIST ${BUILD_LIBS_LIST} Pipeline Qt)
ENDIF(CMTK_USE_QT)

IF(CMTK_USE_CUDA OR CMTK_USE_OPENCL)
  SET(BUILD_LIBS_LIST ${BUILD_LIBS_LIST} GPU)
ENDIF(CMTK_USE_CUDA OR CMTK_USE_OPENCL)

IF(CMTK_BUILD_UNSTABLE)
  SET(BUILD_LIBS_LIST ${BUILD_LIBS_LIST} Unstable)
ENDIF(CMTK_BUILD_UNSTABLE)

FOREACH(lib ${BUILD_LIBS_LIST})
  ADD_SUBDIRECTORY(${lib})
ENDFOREACH(lib ${BUILD_LIBS_LIST})

=== scripts/CMakeLists.txt ===
##
##  Copyright 2009-2011 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3544 $
##
##  $LastChangedDate: 2011-11-03 14:14:15 -0700 (Thu, 03 Nov 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

## Configure scripts for the build tree
SET(CMTK_BINARY_DIR_CONFIG ${CMAKE_BINARY_DIR}/bin)
SET(CMTK_LIBRARY_DIR_CONFIG ${CMAKE_BINARY_DIR}/bin)

SET(SCRIPTS utilities.sh iterative_shape_averaging correct_nex_motion)
FOREACH(s ${SCRIPTS})
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${s}.in ${CMAKE_BINARY_DIR}/bin/${s} @ONLY)
ENDFOREACH(s ${SCRIPTS})

IF(CMTK_BUILD_WRAPPER)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmtk.in ${CMAKE_BINARY_DIR}/bin/cmtk @ONLY)
ENDIF(CMTK_BUILD_WRAPPER)

## Configure SCRIPTS for the install tree
# Link directories.
IF(CMTK_BUILD_WRAPPER)
  SET(CMTK_BINARY_DIR_CONFIG ${CMAKE_INSTALL_PREFIX}/${CMTK_INSTALL_LIB_DIR}/bin)
ELSE(CMTK_BUILD_WRAPPER)
  SET(CMTK_BINARY_DIR_CONFIG ${CMAKE_INSTALL_PREFIX}/${CMTK_INSTALL_BIN_DIR})
ENDIF(CMTK_BUILD_WRAPPER)

SET(CMTK_LIBRARY_DIR_CONFIG ${CMAKE_INSTALL_PREFIX}/${CMTK_INSTALL_LIB_DIR})

FOREACH(s ${SCRIPTS})
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${s}.in ${CMAKE_BINARY_DIR}/scripts/${s} @ONLY)
  IF(CMTK_BUILD_WRAPPER)
    INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/scripts/${s} DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT runtime)
  ELSE(CMTK_BUILD_WRAPPER)
    INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/scripts/${s} DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime)
  ENDIF(CMTK_BUILD_WRAPPER)
ENDFOREACH(s ${SCRIPTS})

IF(CMTK_BUILD_WRAPPER)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmtk.in ${CMAKE_BINARY_DIR}/scripts/cmtk @ONLY)
  INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/scripts/cmtk DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime)
ENDIF(CMTK_BUILD_WRAPPER)

=== Utilities/NrrdIO/CMakeLists.txt ===
#
# Modified 11-Apr-2011 by Torsten Rohlfing for CMTK, 
# (C) 2011 SRI International
#

PROJECT(NrrdIO)
INCLUDE_REGULAR_EXPRESSION("^.*.h$")

#
# This CMake file configures the NrrdIO library build.  NrrdIO
# is used by Insight/Code/IO/itkNrrdIO for reading/writing 
# "Nearly Raw Raster Data" within the open-source Teem software 
# package. See http://teem.sourceforge.net for more information.
#

SET(nrrdio_SRCS 754.c mop.c array.c parseAir.c dio.c sane.c endianAir.c 
string.c enum.c miscAir.c biffbiff.c biffmsg.c accessors.c defaultsNrrd.c 
enumsNrrd.c arraysNrrd.c methodsNrrd.c reorder.c axis.c simple.c comment.c 
keyvalue.c endianNrrd.c parseNrrd.c gzio.c read.c write.c format.c 
formatNRRD.c encoding.c encodingRaw.c encodingAscii.c encodingHex.c 
encodingGzip.c subset.c encodingBzip2.c formatEPS.c formatPNG.c 
formatPNM.c formatText.c formatVTK.c )

# Turn on TEEM_BUILD so that the proper dll export def's are 
# used on windows builds.
ADD_DEFINITIONS(-DTEEM_BUILD=1)

# Configure files with settings for use by the build.
CONFIGURE_FILE(${NrrdIO_SOURCE_DIR}/NrrdConfigure.h.in 
  ${NrrdIO_BINARY_DIR}/NrrdConfigure.h)

# Need to be able to fine NrrdConfig.h
INCLUDE_DIRECTORIES(
        ${NrrdIO_BINARY_DIR} 
)

# Set compiler flags for endian-ness.
#IF(CMAKE_WORDS_BIGENDIAN)
#  ADD_DEFINITIONS(-DTEEM_ENDIAN=4321)
#ELSE(CMAKE_WORDS_BIGENDIAN)
#  ADD_DEFINITIONS(-DTEEM_ENDIAN=1234)
#ENDIF(CMAKE_WORDS_BIGENDIAN)

#The QNANHIBIT variable is configured by the root level CMakeLists.txt
IF(QNANHIBIT)
  ADD_DEFINITIONS(-DTEEM_QNANHIBIT=1)
ELSE(QNANHIBIT)
  ADD_DEFINITIONS(-DTEEM_QNANHIBIT=0)
ENDIF(QNANHIBIT)

#DirectIO is the fast way to do multi-gigabyte I/O and currently only available
#for SGI platforms.  Use of DirectIO is enabled manually for now.
#OPTION(USE_DIRECTIO "Use DirectIO for Nrrd file IO.  Only valid on SGI systems." 0)
#MARK_AS_ADVANCED(USE_DIRECTIO)
#IF(USE_DIRECTIO)
#  ADD_DEFINITIONS(-DTEEM_DIO=1)
#ELSE(USE_DIRECTIO)
  ADD_DEFINITIONS(-DTEEM_DIO=0)
#ENDIF(USE_DIRECTIO)

# Tell NRRD to enable nrrdEncodingGzip
ADD_DEFINITIONS(-DTEEM_ZLIB=1)

IF(CMAKE_COMPILER_IS_GNUCXX)
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-strict-aliasing")
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

##
## CMTK-speficic add-ons
##

INCLUDE_DIRECTORIES(BEFORE
  ${ZCONF_INCLUDE_DIR}
  ${ZLIB_INCLUDE_DIR})

ADD_LIBRARY(NrrdIO ${nrrdio_SRCS} )
TARGET_LINK_LIBRARIES(NrrdIO ${ZLIB_LIBRARIES})

INSTALL(TARGETS NrrdIO
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

FILE(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
INSTALL(FILES ${files} DESTINATION ${CMTK_INSTALL_INCLUDE_DIR} COMPONENT headers)

=== gui/bsedit/CMakeLists.txt ===
##
##  Copyright 1997-2009 Torsten Rohlfing
##
##  Copyright 2004-2011 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3549 $
##
##  $LastChangedDate: 2011-11-03 15:01:39 -0700 (Thu, 03 Nov 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

QT4_WRAP_UI(BSEDIT_UIS_H bseditMainWindow.ui)

SET(bsedit_SRCS
  cmtkBinarySegmentationEditorApplication.cxx
  )

SET(bsedit_MOC_SRCS
  cmtkBinarySegmentationEditorApplication.h
  )

INCLUDE_DIRECTORIES(
  ${CMAKE_CURRENT_BINARY_DIR}
  )

IF(QT_WRAP_CPP)
  QT_WRAP_CPP(bsedit bsedit_SRCS ${bsedit_MOC_SRCS} )
ENDIF(QT_WRAP_CPP)

ADD_EXECUTABLE(bsedit main.cxx ${bsedit_SRCS} ${BSEDIT_UIS_H})
TARGET_LINK_LIBRARIES(bsedit ${CMTK_LIBRARIES} ${QT_LIBRARIES} ${CMTK_SYSTEM_LIBRARIES})

IF(CMTK_BUILD_WRAPPER)
  INSTALL(TARGETS bsedit RUNTIME DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT gui)
ELSE(CMTK_BUILD_WRAPPER)    
  INSTALL(TARGETS bsedit RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT gui)
ENDIF(CMTK_BUILD_WRAPPER)

=== libs/Base/CMakeLists.txt ===
##
##  Copyright 1997-2010 Torsten Rohlfing
##
##  Copyright 2004-2011 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3342 $
##
##  $LastChangedDate: 2011-08-09 13:10:49 -0700 (Tue, 09 Aug 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

# Sources of non-templated classes.
SET(cmtkBase_SRCS
  cmtkActiveDeformationModel.cxx
  cmtkActiveShapeModel.cxx
  cmtkAffineXform.cxx
  cmtkAffineXformUniformVolume.cxx
  cmtkAnatomicalOrientation.cxx
  cmtkAnatomicalOrientationBase.cxx
  cmtkAnatomicalOrientationPermutationMatrix.cxx
  cmtkBitVector.cxx
  cmtkControlPoint.cxx
  cmtkDataGrid.cxx
  cmtkDataGrid_Crop.cxx
  cmtkDataGridFilter.cxx
  cmtkDataGridConnectedComponents.cxx
  cmtkDataGridLocalCorrelation.cxx
  cmtkDataGridMorphologicalOperators.cxx
  cmtkDataTypeTraits.cxx
  cmtkDeformationField.cxx
  cmtkDeformationField_Jacobian.cxx
  cmtkDirectionSet.cxx
  cmtkFilterVolume.cxx
  cmtkFunctional.cxx
  cmtkGeneralLinearModel.cxx
  cmtkHistogram.cxx
  cmtkHypothesisTests.cxx
  cmtkImageOperation.cxx
  cmtkImageOperationCropRegion.cxx
  cmtkImageOperationCropThreshold.cxx
  cmtkImageOperationDistanceMap.cxx
  cmtkImageOperationDownsample.cxx
  cmtkImageOperationHistogramEqualization.cxx
  cmtkImageOperationMapValues.cxx
  cmtkImageOperationRegionFilter.cxx
  cmtkImageOperationMedialSkeleton.cxx
  cmtkImageOperationScaleToRange.cxx
  cmtkImageOperationThreshold.cxx
  cmtkImageOperationPruneHistogram.cxx
  cmtkImageOperationRevert.cxx
  cmtkIntersection.cxx
  cmtkJointHistogram.cxx
  cmtkJointHistogramBase.cxx
  cmtkLandmark.cxx
  cmtkLandmarkList.cxx
  cmtkMatchedLandmarkList.cxx
  cmtkMathFunctionWrappers.cxx
  cmtkMathUtil_LinAlg.cxx
  cmtkMathUtil_Random.cxx
  cmtkMathUtil_Statistics.cxx
  cmtkMatrix3x3.cxx
  cmtkMatrix4x4.cxx
  cmtkMetaInformationObject.cxx
  cmtkParametricPlane.cxx
  cmtkScalarImage.cxx
  cmtkSegmentationLabel.cxx
  cmtkSplineWarpXform.cxx
  cmtkSplineWarpXform_Inverse.cxx
  cmtkSplineWarpXform_Jacobian.cxx
  cmtkSplineWarpXform_Rigidity.cxx
  cmtkSplineWarpXformUniformVolume.cxx
  cmtkTransformChangeToSpaceAffine.cxx
  cmtkTransformChangeFromSpaceAffine.cxx
  cmtkTransformedVolumeAxes.cxx
  cmtkTypedArray.cxx
  cmtkTypedArray_Statistics.cxx
  cmtkTypedArrayFunctionHistogramMatching.cxx
  cmtkTypedArrayFunctionHistogramEqualization.cxx
  cmtkTypedArrayNoiseEstimatorNaiveGaussian.cxx
  cmtkTypes.cxx
  cmtkUniformDistanceMap.cxx
  cmtkUniformVolume.cxx
  cmtkUniformVolume_Crop.cxx
  cmtkUniformVolume_Differential.cxx
  cmtkUniformVolume_Resample.cxx
  cmtkUniformVolume_Space.cxx
  cmtkUniformVolumeFilter.cxx
  cmtkUniformVolumeInterpolatorBase.cxx
  cmtkUniformVolumeInterpolatorPartialVolume.cxx
  cmtkUniformVolumePainter.cxx
  cmtkVolumeClipping.cxx
  cmtkVolume.cxx
  cmtkVolumeGridToGridLookup.cxx
  cmtkWarpXform.cxx
  cmtkXform.cxx
  cmtkXformList.cxx
  cmtkXformListEntry.cxx
)

ADD_LIBRARY(cmtkBase ${cmtkBase_SRCS})

TARGET_LINK_LIBRARIES(cmtkBase cmtkSystem cmtkNumerics )

IF(CMTK_LIBRARY_PROPERTIES)
  SET_TARGET_PROPERTIES(cmtkBase PROPERTIES ${CMTK_LIBRARY_PROPERTIES})
ENDIF(CMTK_LIBRARY_PROPERTIES)

INSTALL(TARGETS cmtkBase
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

FILE(GLOB files_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
FILE(GLOB files_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")
INSTALL(FILES ${files_h} ${files_txx}  DESTINATION ${CMTK_INSTALL_INCLUDE_DIR}/Base/ COMPONENT headers)

=== libs/GPU/CMakeLists.txt ===
##
##  Copyright 1997-2011 Torsten Rohlfing
##
##  Copyright 2004-2011 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3161 $
##
##  $LastChangedDate: 2011-04-18 14:37:45 -0700 (Mon, 18 Apr 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

# Sources of non-specific classes.
SET(cmtkGPU_SRCS
  cmtkDeviceHistogram.cxx
  cmtkDeviceUniformVolume.cxx
  cmtkDeviceUniformVolumeArray.cxx
  cmtkEntropyMinimizationIntensityCorrectionFunctionalDevice.cxx
  cmtkImagePairAffineRegistrationFunctionalDevice.cxx
  cmtkImageSymmetryPlaneFunctionalDevice.cxx
  cmtkSimpleLevelsetDevice.cxx
  )

IF(CMTK_USE_CUDA)
  SET(cmtkGPU_SRCS_CUDA
    cmtkDeviceImageConvolution_kernels.cu
    cmtkDeviceHistogram_kernels.cu
    cmtkDeviceMemoryCUDA.cxx
    cmtkDeviceArrayCUDA.cxx
    cmtkEntropyMinimizationIntensityCorrectionFunctionalDevice_kernels.cu
    cmtkImagePairAffineRegistrationFunctionalDevice_kernels.cu
    cmtkSimpleLevelsetDevice_kernels.cu
    cmtkSumReduction_kernel.cu
    )

  CUDA_ADD_LIBRARY(cmtkGPU ${cmtkGPU_SRCS_CUDA} ${cmtkGPU_SRCS})
ENDIF(CMTK_USE_CUDA)

IF(CMTK_USE_OPENCL)
  SET(cmtkGPU_SRCS_OPENCL
    cmtkDeviceContextCL.cxx
    cmtkDeviceHistogram_kernels.cxx
    cmtkDeviceMemoryCL.cxx
    )
  
  ADD_LIBRARY(cmtkGPU ${cmtkGPU_SRCS_OPENCL} ${cmtkGPU_SRCS})
ENDIF(CMTK_USE_OPENCL)

TARGET_LINK_LIBRARIES(cmtkGPU cmtkSegmentation cmtkRegistration cmtkBase cmtkSystem cmtkNumerics)

IF(CMTK_LIBRARY_PROPERTIES)
  SET_TARGET_PROPERTIES(cmtkGPU PROPERTIES ${CMTK_LIBRARY_PROPERTIES})
ENDIF(CMTK_LIBRARY_PROPERTIES)

INSTALL(TARGETS cmtkGPU
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

FILE(GLOB files_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
FILE(GLOB files_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")
INSTALL(FILES ${files_h} ${files_txx} DESTINATION ${CMTK_INSTALL_INCLUDE_DIR}/GPU COMPONENT headers)

=== libs/IO/CMakeLists.txt ===
##
##  Copyright 2004-2011 SRI International
##
##  Copyright 1997-2009 Torsten Rohlfing
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3486 $
##
##  $LastChangedDate: 2011-10-20 13:27:35 -0700 (Thu, 20 Oct 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

# Sources of non-templated classes.
SET(cmtkIO_SRCS
  cmtkAffineXformITKIO.cxx
  cmtkSplineWarpXformITKIO.cxx
  cmtkClassStreamAffineXform.cxx
  cmtkClassStreamLandmarkList.cxx
  cmtkClassStreamParametricPlane.cxx
  cmtkClassStreamStudyList.cxx
  cmtkClassStreamWarpXform.cxx
  cmtkFileFormat.cxx
  cmtkGroupwiseRegistrationFunctionalIO.cxx
  cmtkImageOperationApplyMask.cxx
  cmtkPGM.cxx
  cmtkResourceFile.cxx
  cmtkScalarImageIO.cxx
  cmtkSegmentationLabelIO.cxx
  cmtkStudy.cxx
  cmtkStudyList.cxx
  cmtkTypedStream.cxx
  cmtkTypedStreamStudylist.cxx
  cmtkVolumeFromFile.cxx
  cmtkVolumeFromFileAnalyze.cxx
  cmtkVolumeFromFileBioRad.cxx
  cmtkVolumeFromFileMetaFile.cxx
  cmtkVolumeFromFileNRRD.cxx
  cmtkVolumeFromFileNifti.cxx
  cmtkVolumeFromFileVanderbilt.cxx
  cmtkVolumeFromSlices.cxx
  cmtkVolumeIO.cxx
  cmtkXformIO.cxx
  cmtkXformListIO.cxx
  cmtkXformIONrrd.cxx
)

IF(CMTK_USE_DCMTK)
  SET(cmtkIO_SRCS ${cmtkIO_SRCS} 
    cmtkDICOM.cxx
    cmtkVolumeFromStudy.cxx
    cmtkVolumeFromFileDICOM.cxx)
ENDIF(CMTK_USE_DCMTK)

IF(CMTK_USE_SQLITE)
  SET(cmtkIO_SRCS ${cmtkIO_SRCS} 
    cmtkSQLite.cxx)
ENDIF(CMTK_USE_SQLITE)

IF(CMTK_USE_MPI)
  SET(cmtkIO_SRCS ${cmtkIO_SRCS} cmtkUniformVolumeMPI.cxx)
ENDIF(CMTK_USE_MPI)

ADD_LIBRARY(cmtkIO ${cmtkIO_SRCS})

TARGET_LINK_LIBRARIES(cmtkIO cmtkBase cmtkSystem cmtkNumerics ${NRRD_LIBRARIES} ${CMTK_SQLITE_LIB} ${DCMTK_LIBRARIES} ${CMTK_ZLIB_LIB})

IF(CMTK_LIBRARY_PROPERTIES)
  SET_TARGET_PROPERTIES(cmtkIO PROPERTIES ${CMTK_LIBRARY_PROPERTIES})
ENDIF(CMTK_LIBRARY_PROPERTIES)

INSTALL(TARGETS cmtkIO
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

FILE(GLOB files_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
FILE(GLOB files_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")
INSTALL(FILES ${files_h} ${files_txx} DESTINATION ${CMTK_INSTALL_INCLUDE_DIR}/IO COMPONENT headers)

=== libs/Pipeline/CMakeLists.txt ===
##
##  Copyright 1997-2009 Torsten Rohlfing
##
##  Copyright 2004-2010 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3161 $
##
##  $LastChangedDate: 2011-04-18 14:37:45 -0700 (Mon, 18 Apr 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

# Sources of non-templated classes.
SET(cmtkPipeline_SRCS
  cmtkColormap.cxx
  cmtkImage.cxx
  cmtkImageEdgeOperator.cxx
  cmtkImageRGB.cxx
  cmtkImageToImageRGB.cxx
  cmtkObject.cxx
  cmtkPipelineObject.cxx
  cmtkPlane.cxx
  cmtkPlaneSource.cxx
  cmtkRenderer.cxx
  cmtkSlicer.cxx
  cmtkVolumeWrapper.cxx
)

ADD_LIBRARY(cmtkPipeline ${cmtkPipeline_SRCS})

TARGET_LINK_LIBRARIES(cmtkPipeline cmtkBase cmtkSystem cmtkNumerics)

IF(CMTK_LIBRARY_PROPERTIES)
  SET_TARGET_PROPERTIES(cmtkPipeline PROPERTIES ${CMTK_LIBRARY_PROPERTIES})
ENDIF(CMTK_LIBRARY_PROPERTIES)

INSTALL(TARGETS cmtkPipeline
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

FILE(GLOB files_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
FILE(GLOB files_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")
INSTALL(FILES ${files_h} ${files_txx} DESTINATION ${CMTK_INSTALL_INCLUDE_DIR}/Pipeline COMPONENT headers)

=== debian/changelog ===
cmtk (2.1.0-1) unstable; urgency=low

  * Initial release (Closes: #626225)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 22 Nov 2011 20:00:37 -0500

=== debian/control ===
Source: cmtk
Section: science
Priority: extra
Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 7.0.50~),
               cmake,
               libmxml-dev,
               libsqlite3-dev,
               zlib1g-dev | libz-dev,
               libdcmtk2-dev | libdcmtk1-dev | libdcmtk-dev,
               libbz2-dev,
               liblzma-dev,
               libqt4-dev, qt4-qmake,
               libpng12-dev | libpng-dev,
               libtiff4-dev | libtiff-dev,
               libwrap0-dev,
               libcharls-dev | libdcmtk1-dev | libdcmtk2-dev (<< 3.6.0-8~),
               libxml2-dev,
               libssl-dev,
               xvfb,
               xauth,
Standards-Version: 3.9.2
Homepage: http://www.nitrc.org/projects/cmtk/
Vcs-Git: git://git.debian.org/pkg-exppsy/cmtk.git
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/cmtk.git;a=summary


Package: cmtk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: sri24-atlas
Description: Computational Morphometry Toolkit
 A software toolkit for computational morphometry of biomedical
 images, CMTK comprises a set of command line tools and a back-end
 general-purpose library for processing and I/O.
 .
 The command line tools primarily provide the following functionality:
 registration (affine and nonrigid; single and multi-channel; pairwise
 and groupwise), image correction (MR bias field estimation;
 interleaved image artifact correction), processing (filters;
 combination of segmentations via voting and STAPLE; shape-based
 averaging), statistics (t-tests; general linear regression).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DISTDIR=$(CURDIR)/debian/cmtk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# custom option tests to provide build for validating unittests
ifneq (,$(findstring docheck,$(DEB_BUILD_OPTIONS)))
	TESTING=ON
	DEB_HOST_ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)
 ifeq ($(DEB_HOST_ARCH),i386)
	TFLAGS=-march=pentium4
 endif
 ifeq ($(DEB_HOST_ARCH),amd64)
	TFLAGS=-march=nocona
 endif
    TFLAGS+=-mmmx -msse -msse2 -mfpmath=sse
	OPT_CMAKE_FLAGS=-DCMAKE_C_FLAGS:STRING="$(TFLAGS)" \
					-DCMAKE_ANSI_CXXFLAGS:STRING="$(TFLAGS)"
else
	TESTING=OFF
	export DEB_BUILD_OPTIONS += " nocheck"
endif

%:
	dh $@ --parallel


override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
		-DBUILD_APPS:BOOL=ON \
		-DBUILD_DOCUMENTATION:BOOL=OFF \
		-DBUILD_GUI:BOOL=ON \
		-DBUILD_SHARED_LIBS:BOOL=ON \
		-DBUILD_TESTING:BOOL=$(TESTING) \
		-DCMTK_BUILD_DCMTK:BOOL=OFF \
		-DCMTK_BUILD_MXML:BOOL=OFF \
		-DCMTK_BUILD_NRRD:BOOL=ON \
		-DCMTK_BUILD_SQLITE:BOOL=OFF \
		-DCMTK_BUILD_ZLIB:BOOL=OFF \
		-DCMTK_ROOT_PATH_SRI24:PATH=/usr/share/doc/sri24-atlas \
		-DCMTK_USE_DCMTK:BOOL=ON \
		-DCMTK_USE_QT:BOOL=ON \
		-DCMTK_USE_SMP:BOOL=ON \
		-DCMTK_USE_SQLITE:BOOL=ON \
		-DDART_TESTING_TIMEOUT:STRING=15000 \
		-DMXML_INCLUDE_DIR:PATH=/usr/include \
		-DLZMA_INCLUDE_DIRS:PATH=/usr/include/lzma \
		-DCMAKE_SKIP_RPATH:BOOL=OFF \
		-DCMTK_BUILD_WRAPPER:BOOL=ON \
		$(OPT_CMAKE_FLAGS)

override_dh_auto_test:
ifneq (,$(findstring docheck,$(DEB_BUILD_OPTIONS)))
	xvfb-run --auto-servernum --server-num=20 \
		dh_auto_test
endif

override_dh_auto_install:
	dh_auto_install

	: # Remove not needed headers, cmake files etc
	rm -fr $(DISTDIR)/usr/include
	-/usr/bin/find $(DISTDIR) -iname *.cmake -delete

	: # Prune duplicate docs
	rm -fr $(DISTDIR)/usr/share/cmtk/doc

	: # Generate manpages
	xvfb-run --auto-servernum --server-num=20 \
		scripts/gen_manpages \
	|| dpkg -l xvfb | awk '/xvfb/{print $3;}' | grep -q ubuntu
	: # Above condition just to ignore unclean exit from xvfb on elderly broken ubuntus
	: # Cleaner solution patches are welcome!

override_dh_installman:
	dh_installman debian/manpages/*

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/manpages

get-orig-source:
	uscan --verbose --rename --force-download

get-orig-source-svn:
	cd ../cmtk.gitsvn && \
	git svn rebase && \
	rev=$$(git show | sed -n -e '/git-svn-id/s/.*@\([0-9]*\) .*/\1/gp') && \
	otgz=cmtk-2.1.0~svn$$rev.tar.gz && \
	sh scripts/make_src_archive.sh && \
	mv CMTK-2.1.0svn-Source.tar.gz $$otgz && \
	cd - && \
	git-import-orig ../cmtk.gitsvn/$$otgz || \
	echo "Failed to git-import-orig ../cmtk.gitsvn/$$otgz"

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

http://www.nitrc.org/frs/?group_id=212 \
  .*/download\.php/.*/CMTK-([.0-9]*)-Source\.tar\.gz
